`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
/*NOTE 
LUT_sin table is a wave look up table with 8 bit  index from 0~255
the range  is pwm duty  0 ~ 255  (VL = 0   VH = 1) 
*/
//////////////////////////////////////////////////////////////////////////////////


module LUT_sin(
    input[7:0] phase_idx,
    output reg[7:0] data
);
    wire [3:0] row_idx, col_idx;
    assign row_idx = phase_idx[7:4];
    assign col_idx = phase_idx[3:0];
    
    reg [127:0] row_data;
    always@(*)begin
        case(row_idx)
            4'h0:row_data = 128'haeaba8a5a29f9c9995928f8c89868380;
            4'h1:row_data = 128'hd8d6d3d1cfccc9c7c4c2bfbcb9b6b4b1;
            4'h2:row_data = 128'hf5f3f2f1efeeeceae8e7e5e3e1dfdcda;
            4'h3:row_data = 128'hfffffffffffefefdfdfcfbfaf9f8f7f6;
            4'h4:row_data = 128'hf7f8f9fafbfbfcfdfdfefeffffffffff;
            4'h5:row_data = 128'hdbdee0e2e4e6e8e9ebedeef0f1f3f4f5;
            4'h6:row_data = 128'hb2b5b8bbbdc0c3c6c8cbcdd0d2d5d7d9;
            4'h7:row_data = 128'h8184878b8e9194979a9da0a3a6a9acaf;
            4'h8:row_data = 128'h505356595c5f6265686b6e7174787b7e;
            4'h9:row_data = 128'h26282a2d2f323437393c3f4244474a4d;
            4'hA:row_data = 128'h0a0b0c0e0f1112141617191b1d1f2124;
            4'hB:row_data = 128'h00000000000101020203040405060708;
            4'hC:row_data = 128'h09080706050403020201010000000000;
            4'hD:row_data = 128'h2523201e1c1a1817151311100e0d0c0a;
            4'hE:row_data = 128'h4e4b494643403d3b383633302e2c2927;
            4'hF:row_data = 128'h7f7c797673706d6a6663605d5a575451;
        endcase
    end
    
    always@(*)begin
        case(col_idx)
            4'h0:data = row_data[7:0];
            4'h1:data = row_data[15:8];
            4'h2:data = row_data[23:16];
            4'h3:data = row_data[31:24];
            4'h4:data = row_data[39:32];
            4'h5:data = row_data[47:40];
            4'h6:data = row_data[55:48];
            4'h7:data = row_data[63:56];
            4'h8:data = row_data[71:64];
            4'h9:data = row_data[79:72];
            4'hA:data = row_data[87:80];
            4'hB:data = row_data[95:88];
            4'hC:data = row_data[103:96];
            4'hD:data = row_data[111:104];
            4'hE:data = row_data[119:112];
            4'hF:data = row_data[127:120];
        endcase
    end
endmodule

