`timescale 10ns / 1ps
module pwm(
    input       rst,
    input       enable,
    input       duty_trig,
    input       phase_trig,
    input [7:0] duty,
    output wire out
);

reg [7:0] count;

assign out = ((count < duty) | phase_trig) & enable;

always @( posedge duty_trig or posedge rst) begin
    if (rst) begin
        count <= 8'b0;
    end else if (phase_trig) begin
        count <= 8'b0;
    end else if (duty_trig) begin
        count <= count + 1;
    end else begin
        count <= count;
    end
end

endmodule
